$startingDir = "c:\\"

def test_skp_efficiency
  model = Sketchup.active_model
  filename = UI.openpanel "Open File", $startingDir, "*.txt"
  $startingDir = File.dirname(filename) + "\\"

  if (filename)
    ##Open and parse the file
    testFile = File.open(filename, "r")

    verts = nil
    groupEnts = nil
    
    numItemsLine = testFile.gets
    numItems = numItemsLine.split(" ")[2].to_i

    for i in (0..(numItems - 1))
      curLine = testFile.gets

      posX = curLine.split(" ")[0].to_f
      posY = curLine.split(" ")[1].to_f
      posZ = curLine.split(" ")[2].to_f
      wid = curLine.split(" ")[3].to_f
      len = curLine.split(" ")[4].to_f

      if i % 500 == 0
        print "item #: ", i.to_s, " posX: ", posX.to_s, " posX(m): ", posX.m.to_s, " posY(m): ", posY.m.to_s, " posZ(m): ", posZ.m.to_s, " Len: ", len.m, " Wid: ", wid.m, "\n"
      end
	      
      #Length is along crease (zUnit), width is along X and Y
      verts = []
      face0Vert0 = Geom::Point3d.new(posX.mm, posY.mm, posZ.mm)
      face0Vert1 = Geom::Point3d.new(posX.mm + wid.mm, posY.mm, posZ.mm)
      face0Vert2 = Geom::Point3d.new(posX.mm + wid.mm, posY.mm + len.mm, posZ.mm)
      face0Vert3 = Geom::Point3d.new(posX.mm, posY.mm + len.mm, posZ.mm)

      verts << face0Vert0
      verts << face0Vert1
      verts << face0Vert2
      verts << face0Vert3

      #status = model.start_operation('Add dheds', true)

      newGroup = model.entities.add_group
      newGroup.name = "face" + i.to_s
      groupEnts = newGroup.entities

      polyMesh = Geom::PolygonMesh.new(4, 1)
     
      plane = Geom::fit_plane_to_points verts
      numVerts = verts.size
      for vertInd in 0..numVerts-1 do
        verts[vertInd] = verts[vertInd].project_to_plane plane
      end

      polyMesh.add_polygon(verts)
  
      groupEnts.fill_from_mesh(polyMesh)
      #model.commit_operation

    end #for loop over items
  end
end
